//+------------------------------------------------------------------+
//|                                                      jpytest.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
extern double LotSize=0.1; //   
int MagicNumber;
int OpenedOrder;

double ExtendPoint=1;   //     ExtendPoint=10


int init()
  {
   return(0);
  }

int deinit()
  {
   return(0);
  }

int start()
 {
  MagicNumber=900;
  datetime curtime=iTime(NULL,PERIOD_M1,0);
  if (ExistPositions(Symbol(),-1 , MagicNumber)) {
   if ((TimeHour(curtime)==5 && TimeMinute(curtime)==55) || (TimeHour(curtime)==6 && TimeMinute(curtime)==0))
   OrderClose(OpenedOrder,LotSize,Ask,3);
  } 
  else {
   if (TimeHour(curtime)==4 && TimeMinute(curtime)==0) 
   iSetOrder(Symbol(), OP_SELL, 20*ExtendPoint,10000);
  }

  MagicNumber=901;
  if (ExistPositions(Symbol(),-1 , MagicNumber)) {
   if ((TimeHour(curtime)==12 && TimeMinute(curtime)==55) || (TimeHour(curtime)==13 && TimeMinute(curtime)==0))
   OrderClose(OpenedOrder,LotSize,Bid,3);
  } 
  else {
   if (TimeHour(curtime)==10 && TimeMinute(curtime)==0) 
   iSetOrder(Symbol(), OP_BUY, 15*ExtendPoint,10000);
  }

  return(0);
 }

bool iSetOrder(string symbol, int cmd, double stoploss, double takeprofit, string comment=""){
int Dist_SL =stoploss; //  SL (pt)
  int Dist_TP =takeprofit; //  TP (pt)
  double Prots=0.10; //  . .
  string Symb=symbol; // . 
  double i=0;
  double SL;
  double TP;
  color arr;
  double price;
   
   
//--------------------------------------------------------------- 2 --
  while(i<5) //   .
  {
  if (cmd==OP_BUY) {
  SL=Bid - New_Stop(stoploss)*Point; //  SL .
  TP=Bid + New_Stop(takeprofit)*Point; //  TP .
  Alert("  Buy.  ..");
  price=Ask;
  arr=Maroon; 
  } else
  {
  SL=Ask + New_Stop(stoploss)*Point; //  SL .
  TP=Ask - New_Stop(takeprofit)*Point; //  TP .
  price=Bid;
  arr=Green; 
 
  }//if else
  if (stoploss==0) SL=0;
  if (takeprofit==0) TP=0;

  int ticket=OrderSend(symbol,cmd,LotSize,price,3,SL,TP,comment,MagicNumber,0,arr);// Buy  
 
  //--------------------------------------------------------- 7 --
  if (ticket>0) //  :)
  {
  Alert ("  Buy ",ticket);
  OpenedOrder=ticket;
  return(True);
  break; //   
  }
  //--------------------------------------------------------- 8 --
  int Error=GetLastError(); //   :(
  switch(Error) //  
  {
  case 135:Alert(" .   ..");
  RefreshRates(); //  
  i=i+1;
  continue; //  . 
  case 136:Alert(" .   ..");
  while(RefreshRates()==false) //   
  Sleep(1); //   
  continue; //  . 
  case 146:Alert("  .  ..");
  Sleep(500); //  
  i=i+0.3;
  RefreshRates(); //  
  continue; //  . 
  }
  switch(Error) //  
  {
  case 2 : Alert(" .");
  break; //   switch
  case 5 : Alert("   .");
  break; //   switch
  case 64: Alert(" .");
  break; //   switch
  case 133:Alert(" ");
  break; //   switch
  default: Alert("  ",Error);//    
  }
  break; //   
  }
//--------------------------------------------------------------- 9 --
  return(False);  
}
int New_Stop(int Parametr) //  -.
  {
  int Min_Dist=MarketInfo(Symbol(),MODE_STOPLEVEL);// . 
  if (Parametr < Min_Dist) //   .
  {
  Parametr=Min_Dist; //  .
  Alert("  -.");
  }
  return(Parametr); //  
  }

bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
  if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
  if (OrderSymbol()==sy || sy=="") {
  if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
  if (op<0 || OrderType()==op) {
  if (mn<0 || OrderMagicNumber()==mn) {
  if (ot<=OrderOpenTime()) return(True);
  }
  }
  }
  }
  }
  }
  return(False);
}

